/** @file
 * @brief Util class implementation.
 *
 *
 *
 * @copyright Intra2net AG
 * @license GPLv2
*/

#include "util.h"

#include <stdio.h>
#include <openssl/evp.h>
#include <openssl/md5.h>

Util::Util()
{
}

Util::~Util()
{
}

/**
 * Computes a MD5 Digest from the given string and returns the HEX representation
 * @param data The string to compute the md5 for
 * @return The computed md5 in hex
 */
std::string Util::compute_md5_digest(std::string data)
{
    // compute an MD5 digest.

    string result;
    EVP_MD_CTX mdctx;
    const EVP_MD *md;
    unsigned char md_value[EVP_MAX_MD_SIZE];
    unsigned int md_len;

    OpenSSL_add_all_digests();

    md = EVP_get_digestbyname("md5");

    EVP_MD_CTX_init(&mdctx);
    EVP_DigestInit_ex(&mdctx, md, NULL);
    EVP_DigestUpdate(&mdctx, data.c_str(), strlen(data.c_str()));
    EVP_DigestFinal_ex(&mdctx, md_value, &md_len);
    EVP_MD_CTX_cleanup(&mdctx);

    char buffer[2];

    for(int i = 0; i < md_len; i++)
    {
        sprintf(buffer,"%02x", md_value[i]);
        result.append(buffer);
    }

    return result;
}
